#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 CLR_NONE
#property indicator_color2 Silver
#property indicator_color3 Silver
#property indicator_color4 Lime
#property indicator_color5 Red
#property indicator_color6 White

extern string TimeFrame = "Current";
extern int TMAPeriod = 56;
extern int Price = 0;
extern double ATRMultiplier = 1.001;
extern int ATRPeriod = 100;
extern double TrendThreshold = 0.5;
extern bool ShowCenterLine = FALSE;
extern bool alertsOn = FALSE;
extern bool alertsMessage = FALSE;
extern bool alertsSound = FALSE;
extern bool alertsEmail = FALSE;
extern bool MoveEndpointEveryTick = FALSE;
extern int MaxBarsBack = 5000;
double G_ibuf_140[];
double G_ibuf_144[];
double G_ibuf_148[];
double G_ibuf_152[];
double G_ibuf_156[];
double G_ibuf_160[];
int G_timeframe_164;
int Gi_168;
bool Gi_172;
datetime G_time_176;
double Gd_180;
bool G_bool_188;
double Gd_192;
double Gd_200;
double Gd_208;
double G_close_216;
double Gd_224;
double G_close_232 = 0.0;
double Gd_240 = 0.0;
double Gd_248 = 0.0;
string Gsa_256[] = {"M1", "M5", "M15", "M30", "H1", "H4", "D1", "W1", "MN"};
int Gia_260[] = {1, 5, 15, 30, 60, 240, 1440, 10080, 43200};

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   G_bool_188 = MarketInfo(Symbol(), MODE_MARGINCALCMODE) == 0.0 && MarketInfo(Symbol(), MODE_PROFITCALCMODE) == 0.0 && Digits % 2 == 1;
   Gd_180 = MarketInfo(Symbol(), MODE_TICKSIZE);
   if (G_bool_188) Gd_180 = 10.0 * Gd_180;
   G_timeframe_164 = f0_7(TimeFrame);
   IndicatorBuffers(6);
   SetIndexBuffer(0, G_ibuf_140);
   SetIndexBuffer(1, G_ibuf_144);
   SetIndexBuffer(2, G_ibuf_148);
   SetIndexBuffer(3, G_ibuf_152);
   SetIndexBuffer(4, G_ibuf_156);
   SetIndexBuffer(5, G_ibuf_160);
   SetIndexLabel(1, "Trend Tracker " + TimeFrame + " Upper line");
   SetIndexLabel(2, "Trend Tracker " + TimeFrame + " Lower line");
   SetIndexLabel(3, "Trend Tracker(" + TimeFrame + ")");
   SetIndexLabel(4, "Trend Tracker(" + TimeFrame + ")");
   SetIndexLabel(5, "Trend Tracker(" + TimeFrame + ")");
   IndicatorShortName(f0_3(G_timeframe_164) + " Trend Tracker (" + TMAPeriod + ")");
   Gd_192 = 0;
   for (int Li_0 = 1; Li_0 <= TMAPeriod; Li_0++) Gd_192 += Li_0;
   Gd_224 = TMAPeriod + 1 + 2.0 * Gd_192;
   Gd_200 = (TMAPeriod + 1) / (TMAPeriod + 1 + Gd_192);
   G_close_216 = Close[0];
   if (Digits < 4) Gd_208 = 0.1;
   else Gd_208 = 0.001;
   Gi_168 = iBars(NULL, G_timeframe_164) - TMAPeriod - 1;
   return (0);
}

// 52D46093050F38C27267BCE42543EF60
int deinit() {
   return (0);
}

// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   int Li_16;
   double Ld_20;
   int Li_28;
   int Li_32;
   double Ld_36;
   double Ld_44;
   int Li_0 = IndicatorCounted();
   if (Li_0 < 0) return (-1);
   if (Period() > G_timeframe_164) return (0);
   if (Bars - Li_0 == 1 && MathAbs(Close[0] - G_close_232) < Gd_208) {
      if (MoveEndpointEveryTick) {
         G_ibuf_140[0] = f0_0(G_ibuf_140[0]);
         G_ibuf_144[0] = G_ibuf_140[0] + Gd_240;
         G_ibuf_148[0] = G_ibuf_140[0] - Gd_240;
         f0_6(0, Gd_248);
      } else return (0);
   } else {
      G_close_232 = Close[0];
      if (Li_0 > 0) Li_0--;
      Ld_20 = G_timeframe_164 / Period();
      Li_16 = MathMin(Bars - 1, MaxBarsBack);
      Li_16 = MathMin(Li_16, Bars - Li_0 + TMAPeriod * Ld_20);
      Li_28 = 0;
      Li_32 = 999;
      Ld_36 = G_ibuf_140[Li_16 + 1];
      Ld_44 = G_ibuf_140[Li_16 + 1];
      for (int Li_4 = Li_16; Li_4 >= 0; Li_4--) {
         if (G_timeframe_164 == Period()) Li_28 = Li_4;
         else Li_28 = iBarShift(Symbol(), G_timeframe_164, Time[Li_4]);
         if (Li_28 <= Gi_168) {
            if (Li_28 == Li_32) {
               G_ibuf_140[Li_4] = G_ibuf_140[Li_4 + 1] + (Ld_44 - Ld_36) * (1 / Ld_20);
               G_ibuf_144[Li_4] = G_ibuf_140[Li_4] + Gd_240;
               G_ibuf_148[Li_4] = G_ibuf_140[Li_4] - Gd_240;
               f0_6(Li_4, Gd_248);
               continue;
            }
            Li_32 = Li_28;
            Ld_36 = Ld_44;
            Ld_44 = f0_4(Li_28);
            Gd_240 = iATR(NULL, G_timeframe_164, ATRPeriod, Li_28 + 10) * ATRMultiplier;
            if (Gd_240 == 0.0) Gd_240 = 1;
            if (Ld_20 > 1.0) G_ibuf_140[Li_4] = Ld_36 + (Ld_44 - Ld_36) * (1 / Ld_20);
            else G_ibuf_140[Li_4] = Ld_44;
            G_ibuf_144[Li_4] = G_ibuf_140[Li_4] + Gd_240;
            G_ibuf_148[Li_4] = G_ibuf_140[Li_4] - Gd_240;
            Gd_248 = (Ld_44 - Ld_36) / (Gd_240 / ATRMultiplier / 10.0);
            f0_6(Li_4, Gd_248);
         }
      }
   }
   f0_2();
   return (0);
}

// B9CE7D9E248CB7A5F56E37D82D57F919
void f0_6(int Ai_0, double Ad_4) {
   G_ibuf_152[Ai_0] = EMPTY_VALUE;
   G_ibuf_156[Ai_0] = EMPTY_VALUE;
   G_ibuf_160[Ai_0] = EMPTY_VALUE;
   if (ShowCenterLine) {
      if (Ad_4 > TrendThreshold) {
         G_ibuf_152[Ai_0] = G_ibuf_140[Ai_0];
         return;
      }
      if (Ad_4 < -1.0 * TrendThreshold) {
         G_ibuf_156[Ai_0] = G_ibuf_140[Ai_0];
         return;
      }
      G_ibuf_160[Ai_0] = G_ibuf_140[Ai_0];
   }
}

// 903F1C1EE8C338A3230B05F557408C88
double f0_4(int Ai_0) {
   double Ld_ret_4;
   if (Ai_0 >= TMAPeriod) Ld_ret_4 = f0_8(Ai_0);
   else Ld_ret_4 = f0_1(Ai_0);
   return (Ld_ret_4);
}

// CC050DAD7B3651CD3E7C3D52520C2185
double f0_8(int Ai_0) {
   int Li_4 = TMAPeriod + 1;
   double Ld_12 = Li_4 * iClose(NULL, G_timeframe_164, Ai_0);
   for (int Li_8 = 1; Li_8 <= TMAPeriod; Li_8++) Ld_12 += (Li_4 - Li_8) * (iClose(NULL, G_timeframe_164, Ai_0 + Li_8) + iClose(NULL, G_timeframe_164, Ai_0 - Li_8));
   return (Ld_12 / Gd_224);
}

// 222A334EDF2724416B08BDDA76348BA1
double f0_1(int Ai_0) {
   double Ld_4 = 0;
   int Li_24 = TMAPeriod + 1;
   double Ld_12 = 0;
   for (int Li_20 = 0; Li_20 <= TMAPeriod; Li_20++) {
      Ld_4 += (Li_24 - Li_20) * iClose(NULL, G_timeframe_164, Ai_0 + Li_20);
      Ld_12 += Li_24 - Li_20;
   }
   Li_24 = TMAPeriod;
   for (Li_20 = Ai_0 - 1; Li_20 >= 0; Li_20--) {
      Ld_4 += Li_24 * iClose(NULL, G_timeframe_164, Li_20);
      Ld_12 += Li_24;
      Li_24--;
   }
   G_close_216 = Close[0];
   return (Ld_4 / Ld_12);
}

// 190A99B57C72570C0916838940E72B6D
double f0_0(double Ad_0) {
   double Ld_ret_8 = Ad_0 + (Close[0] - G_close_216) * Gd_200;
   G_close_216 = Close[0];
   return (Ld_ret_8);
}

// 304CD8F881C2EC9D8467D17452E084AC
void f0_2() {
   int Li_0;
   if (alertsOn) {
      if (Close[0] > G_ibuf_144[0]) Li_0 = 1;
      else {
         if (Close[0] < G_ibuf_148[0]) Li_0 = -1;
         else Gi_172 = FALSE;
      }
      if ((!Gi_172) && G_time_176 != Time[0]) {
         if (Li_0 == 1) f0_9("up");
         if (Li_0 == -1) f0_9("down");
      }
   }
}

// DA717D55A7C333716E8D000540764674
void f0_9(string As_0) {
   string str_concat_8;
   if (Gi_172 == FALSE) {
      Gi_172 = TRUE;
      G_time_176 = Time[0];
      str_concat_8 = StringConcatenate(Symbol(), " at ", TimeToStr(TimeLocal(), TIME_SECONDS), " " + f0_3(G_timeframe_164) + " Trend Tracker price penetrated ", As_0, " band");
      if (alertsMessage) Alert(str_concat_8);
      if (alertsEmail) SendMail(StringConcatenate(Symbol(), "Trend Tracker "), str_concat_8);
      if (alertsSound) PlaySound("alert2.wav");
   }
}

// B9EDCDEA151586E355292E7EA9BE516E
int f0_7(string As_0) {
   As_0 = f0_5(As_0);
   for (int Li_8 = ArraySize(Gia_260) - 1; Li_8 >= 0; Li_8--)
      if (As_0 == Gsa_256[Li_8] || As_0 == "" + Gia_260[Li_8]) return (Gia_260[Li_8]);
   return (Period());
}

// 7D88CF3FD85F1B80B60FD9BDB9E59896
string f0_3(int Ai_0) {
   for (int Li_4 = ArraySize(Gia_260) - 1; Li_4 >= 0; Li_4--)
      if (Ai_0 == Gia_260[Li_4]) return (Gsa_256[Li_4]);
   return ("");
}

// 92DFF40263F725411B5FB6096A8D564E
string f0_5(string As_0) {
   int Li_20;
   string Ls_ret_8 = As_0;
   for (int Li_16 = StringLen(As_0) - 1; Li_16 >= 0; Li_16--) {
      Li_20 = StringGetChar(Ls_ret_8, Li_16);
      if ((Li_20 > '`' && Li_20 < '{') || (Li_20 > '' && Li_20 < 256)) Ls_ret_8 = StringSetChar(Ls_ret_8, Li_16, Li_20 - 32);
      else
         if (Li_20 > -33 && Li_20 < 0) Ls_ret_8 = StringSetChar(Ls_ret_8, Li_16, Li_20 + 224);
   }
   return (Ls_ret_8);
}
